//自定义验证规则
rules = {
    0: 'required',
    1: 'number',
    2: 'digits',
    3: 'dateISO',
    4: 'dateISO',
    5: 'datetime',
    6: 'phone',
    7: 'image',
    8: 'name',
    9: 'dept'
};
//设置表单元素
function setForm(id,code) {
    var obj = typeof id == 'string' ? $('#' + id) : id;
    obj.find('table').css('border-collapse', 'collapse');
    obj.find('td').each(function (i) {
        var td = $(this);
        var text = td.text() == String.fromCharCode(160) ? '' : td.text();
        if (td.attr('rule') == undefined && (text == '' || /{.*}/.test(text))) {
            td.attr('rule', text).empty();
            text = '';
        }
        var rule = td.attr('rule');
        if (rule == '') {
            var input = $('<input type="text" id="td' + i + '" name="td' + i + '" value="' + text + '" style="width:96%;border:1px dotted gray;background-color:transparent;" data-role="none">');
            if (td.hasClass(code))
                td.empty().append(input);
        }
        else {
            if (/{.*}/.test(rule)) {
                var ruleVal = /{(.*)}/.exec(td.attr('rule'))[1];
                if (ruleVal == '' || ruleVal == ' ') {
                    var input = $('<textarea id="td' + i + '" name="td' + i + '" style="width:99%;height:' + td.height() + 'px;border:1px dotted gray;background-color:transparent;" data-role="none">' + text.replace(/<br>/g, '\n') + '</textarea>');
                    if (ruleVal == ' ')
                        input.addClass("required");
                }
                else if(ruleVal == 7)
                {
                    var input = $('<img id="td' + i + '" name="td' + i + '" style="position:absolute; z-index:-1;display:none" />');
                }
                else {
                    ruleVal = ruleVal.split(',');
                    if (ruleVal.length == 1) {
                        var input = $('<input type="text" id="td' + i + '" name="td' + i + '" value="' + text + '" style="width:96%;border:1px dotted gray;background-color:transparent;" data-role="none">');
                        if (isNaN(ruleVal[0]))
                            input.val(ruleVal[0])
                        else
                            if (ruleVal[0].length == 1)
                                switch (ruleVal[0]) {
                                    case "0":
                                        input.addClass("required");
                                        break;
                                    case "3":
                                        input.addClass("required");
                                        if (getCookie("Mobile"))
                                            input.attr("type", "date");
                                        else
                                            input.addClass(rules[ruleVal[0]]).datetimepicker();
                                        break;
                                    case "4":
                                        if (getCookie("Mobile"))
                                            input.attr("type", "date");
                                        else
                                            input.addClass(rules[ruleVal[0]]).datetimepicker();
                                        break;
                                    case "5":
                                        input.addClass("required");
                                        if (getCookie("Mobile"))
                                            input.attr("type", "datetime-local");
                                        else
                                            input.addClass(rules[ruleVal[0]]).datetimepicker({ timepicker: true, format: 'Y-m-d H:i:s' });
                                        break;
                                    case "8":
                                        input.val(parent.window.UserData[rules[8]]);
                                        input.attr("disabled", "true");
                                        break;
                                    case "9":
                                        input.val(parent.window.UserData[rules[9]]);
                                        input.attr("disabled", "true");
                                        break;
                                    default:
                                        input.addClass("required");
                                        input.addClass(rules[ruleVal[0]]);
                                }
                            else
                                input.val(parseFloat(ruleVal[0]));
                    }
                    else {
                        var input = $('<select id="td' + i + '" name="td' + i + '" style="width:99%;border:1px dotted gray;background-color:transparent;" data-role="none">');
                        for (i = 0; i < ruleVal.length; i++)
                            input.append($('<option' + (ruleVal[i] == text ? ' selected="selected"' : '') + '>' + ruleVal[i] + '</option>'));
                    }
                }
                if (td.hasClass(code))
                    td.empty().append(input);
            }
        }
    });
}
//获取表单数据
function getForm(id) {
    var json = '';
    var obj = typeof id == 'string' ? $('#' + id) : id;
    obj.find('td input,textarea,select').each(function (i) {
        var elm = $(this);
        json += (json.length == 0 ? '' : ',') + '"' + elm.prop('name') + '":"' + fmtJson(elm.val()) + '"';
        this.parentNode.innerHTML = elm.val().length == 0 ? '&nbsp;' : elm.val();
    });
    return json;
}
//格式化JSON数据
function fmtJson(str) {
    var rs = "";
    for (var i = 0; i < str.length; i++) {
        var chr = str.substr(i, 1)
        switch (chr) {
            case '\"':
                rs = rs + '\\\"'; break;
            case '\\':
                rs = rs + '\\\\'; break;
            case '/':
                rs = rs + '\\/'; break;
            case '\b':
                rs = rs + '\\b"'; break;
            case '\f':
                rs = rs + '\\f'; break;
            case '\n':
                rs = rs + '\\n'; break;
            case '\r':
                rs = rs + '\\r'; break;
            case '\t':
                rs = rs + '\\t'; break;
            default:
                rs = rs + chr; break;
        }
    }
    return rs;
}
//获取cookie
function getCookie(cname) {
    var name = cname + "=";
    var ca = document.cookie.split(';');
    for (var i = 0; i < ca.length; i++) {
        var c = ca[i];
        while (c.charAt(0) == ' ') c = c.substring(1);
        if (c.indexOf(name) != -1) return c.substring(name.length, c.length);
    }
    return "";
}